RYD_bullexc = 
	[
	"Sh_40_SABOT",
	"Sh_40_HE",
	"B_145x115_AP",
	"B_30x113mm_M789_HEDP",
	"B_30mmA10_AP",
	"B_20mm_AP",
	"B_20mm_AA",
	"B_23mm_AA",
	"B_23mm_HE",
	"B_23mm_AP",
	"B_23mm_APHE",
	"B_25mm_HE",
	"B_25mm_HEI",
	"B_25mm_APDS",
	"B_30mm_AP",
	"B_30mm_HE",
	"B_30mm_AA",
	"G_40mm_HE"
	];
	
RYD_AnimOut = 
	[
	"hmmwv_gunner01",
	"hmmwv_gunner04",
	"lav25_gunner2",
	"btr40_gunner_ep1",
	"btr40_driver_ep1",
	"m113_gunner_ep1",
	"m113_driverout_ep1",
	"stryker_driverout_ep1",
	"stryker_commanderout_ep1",
	"m2a2_driverout_ep1",
	"m2a2_gunnerout_ep1",
	"m2a2_commanderout_ep1"
	];

RYD_CrewDamage = 
	{
	private ["_unit","_damage","_state","_arrState","_ct","_imp","_veh","_eh"];

	_unit = _this select 0;
	
	if (_unit == (vehicle _unit)) exitWith
		{
		_eh = _unit getVariable "CrewEH";
		//diag_log format ["exception: %1 typ: %2 alive: %3 eh: %4",_unit,typeOf _unit,alive _unit,_eh];
		if not (isNil "_eh") then
			{
			_unit removeEventHandler ["HandleDamage",_eh];
			_unit setVariable ["CrewEH",nil]
			};
			
		_this select 2
		};

	_damage = 0;

	_state = animationState _unit;

	_arrState = toArray _state;
	_ct = count _arrState;
	_imp = _arrState select (_ct - 3);

	if (_imp == 111) then
		{
		_imp = _arrState select (_ct - 2);
		if (_imp == 117) then
			{
			_imp = _arrState select (_ct - 1);
			if (_imp == 116) then
				{
				_damage = _this select 2
				}
			}
		}
	else
		{
		if (_state in RYD_AnimOut) then
			{
			_damage = _this select 2
			}
		else
			{
			_veh = vehicle _unit;
			if (_state in ["t55_gunner_ep1","t55_commander_ep1"]) then
				{
				if (_veh isKindOf "T55_Base") then
					{
					_beh = behaviour _unit;
					if (_beh in ["SAFE","CARELESS"]) then
						{
						_damage = _this select 2
						}
					}
				}
			else
				{
				if ((_veh isKindOf "GAZ_Vodnik") or (_veh isKindOf "BRDM2_Base")) then
					{
					if (_state in ["gaz_gunner"]) then
						{
						_damage = _this select 2
						}
					}
				}
			}
			
		};
		
	_damage
	};
	
RYD_DistOrd = 
	{
	private ["_array","_point","_final","_closest","_ix"];

	_array = _this select 0;
	_point = _this select 1;

	_final = [];

	while {((count _array) > 0)} do
		{
		_closest = [_point,_array] call RYD_FindClosestWithIndex;
		_ix = _closest select 1;
		_closest = _closest select 0;
		
		_final set [(count _final),_closest];

		_array set [_ix,"Delete"];
		_array = _array - ["Delete"]
		};

	_final
	};
	
RYD_FindClosestWithIndex = 
	{
	private ["_ref","_objects","_closest","_dstMin","_dstAct","_index","_clIndex"];

	_ref = _this select 0;
	_objects = _this select 1;

	_closest = objNull;

	if ((count _objects) > 0) then 
		{
		_closest = _objects select 0;
		_index = 0;
		_clIndex = 0;
		_dstMin = _ref distance _closest;

			{
			_dstAct = _ref distance _x;

			if (_dstAct < _dstMin) then
				{
				_closest = _x;
				_dstMin = _dstAct;
				_clIndex = _index
				};

			_index = _index + 1
			}
		foreach _objects
		};

	[_closest,_clIndex]
	};
		
RYD_LOSCheck = 
	{
	private ["_pos1","_pos2","_tint","_lint","_isHidden","_cam","_target","_pX1","_pY1","_pX2","_pY2","_pos1ATL","_pos2ATL","_level"];

	_pos1 = _this select 0;
	_pos2 = _this select 1;
	_level = 1.5;
	if ((count _this) > 2) then {_level = _this select 2};

	_pX1 = _pos1 select 0;
	_pY1 = _pos1 select 1;

	_pX2 = _pos2 select 0;
	_pY2 = _pos2 select 1;

	_pos1ATL = [_pX1,_pY1,_level];
	_pos2ATL = [_pX2,_pY2,_level];

	_cam = objNull;

	if ((count _this) > 3) then {_cam = _this select 3};

	_target = objNull;

	if ((count _this) > 4) then {_target = _this select 4};

	_tint = terrainintersect [_pos1ATL, _pos2ATL];
	_lint = lineintersects [_pos1, _pos2,_cam,_target]; 

	_isHidden = false;

	if ((_tint) or (_lint)) then {_isHidden = true};

	_isHidden
	};
	
RYD_AngTowards = 
	{
	private ["_source0", "_target0", "_rnd0","_dX0","_dY0","_angleAzimuth0"];

	_source0 = _this select 0;
	_target0 = _this select 1;
	_rnd0 = _this select 2;

	_dX0 = (_target0 select 0) - (_source0 select 0);
	_dY0 = (_target0 select 1) - (_source0 select 1);

	_angleAzimuth0 = (_dX0 atan2 _dY0) + (random (2 * _rnd0)) - _rnd0;

	_angleAzimuth0
	};
	
RYD_WhereIs = 
	{
	private ["_point","_Rpoint","_angle","_diffA","_axis","_isFlanking"];	

	_point = _this select 0;
	_rPoint = _this select 1;
	_axis = _this select 2;
	
	if ((typeName _point) == "OBJECT") then
		{
		_point = getPosATL _point
		};
		
	if ((typeName _rPoint) == "OBJECT") then
		{
		_rPoint = getPosATL _rPoint
		};

	_angle = [_rPoint,_point,0] call RYD_AngTowards;

	_isFlanking = false;

	if (_angle < 0) then {_angle = _angle + 360};
	if (_axis < 0) then {_axis = _axis + 360};  

	_diffA = _angle - _axis;

	if (_diffA < 0) then {_diffA = _diffA + 360};

	if ((_diffA > 20) and (_diffA < 340)) then 
		{
		_isFlanking = true
		};

	_isFlanking
	};

RYD_PosTowards2D = 
	{
	private ["_source","_distT","_angle","_dXb","_dYb","_px","_py","_pz"];

	_source = _this select 0;
	_angle = _this select 1;
	_distT = _this select 2;

	_dXb = _distT * (sin _angle);
	_dYb = _distT * (cos _angle);

	_px = (_source select 0) + _dXb;
	_py = (_source select 1) + _dYb;

	_pz = getTerrainHeightASL [_px,_py];

	[_px,_py,_pz]
	};
	
